/************************************************************************************/
/*  Program name CAPFNDIMP_DOC_SEQ_ASSIGN.sql                                       */
/*  Creater:  WONG Wing Kin (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 30 NOV, 2005   WONG Wing Kin         First created                               */
/************************************************************************************/
SET SERVEROUTPUT ON SIZE 1000000;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFNDIMP_DOC_SEQ_ASSIGN';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	CURSOR Cur_F IS
	SELECT
		*
	FROM
		CRST_FND_DOC_SEQ_ASSIGN;

	lv_Next_Seq_ID	NUMBER;

BEGIN

	FOR C1 IN Cur_F LOOP
		BEGIN
			SELECT	FND_DOC_SEQUENCE_ASSIGNMENTS_S.NextVal
			INTO	lv_Next_Seq_ID
			FROM	DUAL;

			INSERT INTO CRST_FND_DOC_SEQ_ASSIGN_MAP VALUES
			(
			C1.DOC_SEQUENCE_ASSIGNMENT_ID,
			lv_Next_Seq_ID
			);

			INSERT INTO FND_DOC_SEQUENCE_ASSIGNMENTS
			VALUES
			(
			lv_Next_Seq_ID,												--DOC_SEQUENCE_ASSIGNMENT_ID,
			C1.LAST_UPDATE_DATE,
			CAPBRIMP_COMMON.GetUser(C1.LAST_UPDATED_BY_NAME),			--LAST_UPDATED_BY,
			C1.CREATION_DATE,
			CAPBRIMP_COMMON.GetUser(C1.CREATED_BY_NAME),				--CREATED_BY,
			C1.LAST_UPDATE_LOGIN,
			C1.APPLICATION_ID,
			CAPBRIMP_MAPPING.GetFNDDocSeqIDMapping(C1.DOC_SEQUENCE_ID),	--DOC_SEQUENCE_ID,
			C1.CATEGORY_CODE,
			C1.START_DATE,
			C1.END_DATE,
			CAPBRIMP_COMMON.GetSOBID(C1.SOB_SHORT_NAME),				--SET_OF_BOOKS_ID,
			C1.METHOD_CODE,
			C1.ATTRIBUTE_CATEGORY_DEVELOPER,
			C1.ATTRIBUTE_CATEGORY,
			C1.ATTRIBUTE1,
			C1.ATTRIBUTE2,
			C1.ATTRIBUTE3,
			C1.ATTRIBUTE4,
			C1.ATTRIBUTE5,
			C1.ATTRIBUTE6,
			C1.ATTRIBUTE7,
			C1.ATTRIBUTE8,
			C1.ATTRIBUTE9,
			C1.ATTRIBUTE10
			);
		EXCEPTION
			WHEN OTHERS THEN
				DBMS_OUTPUT.Put_Line(SQLERRM);
				lv_Err_Count	:=	lv_Err_Count + 1;
		END;
		lv_Scc_Count	:=	lv_Scc_Count	+	1;
	END LOOP;

	IF	lv_Err_Count	>	0	THEN
		ROLLBACK;
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
